/*
 *  Portable binary serialisation of integral types.
 *  Copyright (C) 2009 Nick Bowler
 *
 *  Copying and distribution of this file, with or without modification,
 *  are permitted in any medium without royalty provided the copyright
 *  notice and this notice are preserved.  This file is offered as-is,
 *  without any warranty.
 */

#ifndef PACK_H_
#define PACK_H_

#include <limits.h>

void pack_16_be(unsigned char *, unsigned short);
void pack_32_be(unsigned char *, unsigned long);
#ifdef ULLONG_MAX
void pack_64_be(unsigned char *, unsigned long long);
#endif

void pack_16_le(unsigned char *, unsigned short);
void pack_32_le(unsigned char *, unsigned long);
#ifdef ULLONG_MAX
void pack_64_le(unsigned char *, unsigned long long);
#endif

unsigned short unpack_16_be(const unsigned char *);
unsigned long  unpack_32_be(const unsigned char *);
#ifdef ULLONG_MAX
unsigned long long unpack_64_be(const unsigned char *);
#endif

unsigned short unpack_16_le(const unsigned char *);
unsigned long  unpack_32_le(const unsigned char *);
#ifdef ULLONG_MAX
unsigned long long unpack_64_le(const unsigned char *);
#endif

short unpack_s16_be(const unsigned char *);
long  unpack_s32_be(const unsigned char *);
#ifdef LLONG_MAX
long long unpack_s64_be(const unsigned char *);
#endif

short unpack_s16_le(const unsigned char *);
long  unpack_s32_le(const unsigned char *);
#ifdef LLONG_MAX
long long unpack_s64_le(const unsigned char *);
#endif

#endif
